; PDL Casper-RW Creator is 2011 Lance http://www.pendrivelinux.com (Offered Under GNU GPL License - See Copying)
; dd.exe 2011 John Newbigin http://www.chrysocome.net/dd (unmodified binary used)
; mke2fs.exe 2011 Matt WU http://ext2fsd.sourceforge.net (unmodified binary used)
; NSIS Installer 2011 Contributors http://nsis.sourceforge.net/License
; You need to install NSIS to compile this script. http://nsis.sourceforge.net/Download

!define NAME "PDL-Casper-RW-Creator"
!define DISTRO "Persistent File"
!define PTYPE "Casper-RW"
!define VERSION "v0.4"
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\win-install.ico"
RequestExecutionLevel highest
Name "${NAME} ${VERSION}"
OutFile "${NAME}.exe"

SetCompressor LZMA
CRCCheck On
XPStyle on
ShowInstDetails show
BrandingText "PDL Casper-RW Creator http://www.pendrivelinux.com"
CompletedText "Installation Done, Process is Complete!"
InstallButtonText Create

!include "MUI2.nsh"
!include "Sections.nsh"
!include "FileFunc.nsh"

; Interface settings
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "casper-rw-creator.bmp" 
!define MUI_HEADERIMAGE_BITMAP_NOSTRETCH
!define MUI_HEADERIMAGE_RIGHT

; License page
!define MUI_TEXT_LICENSE_SUBTITLE $(License_Subtitle)
!define MUI_LICENSEPAGE_TEXT_TOP $(License_Top)
!define MUI_LICENSEPAGE_TEXT_BOTTOM $(License_Bottom)
!insertmacro MUI_PAGE_LICENSE "license.txt"

; Variables
Var PageDescr
Var DriveSelect
Var DestDriveHW
Var DestDrive
Var Casper
Var CasperSelection
Var CasperSlider
Var SlideSpot

; USB Drive and Casper Slider Selections Page
Page custom SelectionsPage

; Install Files Page
!define MUI_INSTFILESPAGE_COLORS "00FF00 000000" ;Green and Black
!define MUI_TEXT_INSTALLING_TITLE $(Install_Title)
!define MUI_TEXT_INSTALLING_SUBTITLE $(Install_SubTitle)
!define MUI_TEXT_FINISH_SUBTITLE $(Install_Finish_Sucess)
!insertmacro MUI_PAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English" ;first language is the default language
LangString License_Subtitle ${LANG_ENGLISH} "Please review the license terms before running ${NAME}."
LangString License_Top ${LANG_ENGLISH} "The software within this program falls under the following License."
LangString License_Bottom ${LANG_ENGLISH} "You must accept the terms of this License agreement to run PDL Casper-RW Creator. If you agree, Click I Agree to Continue."
LangString DrivePage_Title ${LANG_ENGLISH} "Choose your USB drive"
LangString DrivePage_Title2 ${LANG_ENGLISH} "Choose the USB drive in which to install a ${DISTRO}."
LangString DrivePage_Text ${LANG_ENGLISH} "This simple tool can be used to create a Casper-RW ${DISTRO} on your select USB drive, enabling you to save and restore changes on Live Ubuntu based Distributions and Remixes.$\r$\n$\r$\nSelect your Flash Drive, Drag the slider to set your persistent file size and Click Create."
LangString DrivePage_Input ${LANG_ENGLISH} "Step 1: Select your USB Flash Drive Letter"
LangString Casper_Text ${LANG_ENGLISH} "Step 2: Drag the Slider to Set a File Size to use for storing changes."
LangString Install_Title ${LANG_ENGLISH} "Installing a ${PTYPE} ${DISTRO}"
LangString Install_SubTitle ${LANG_ENGLISH} "Please wait while ${NAME} creates and installs a ${PTYPE} ${DISTRO} on $0"
LangString Install_Finish_Sucess ${LANG_ENGLISH} "${NAME} sucessfully created and installed a ${PTYPE} ${DISTRO} on $0"

Function SelectionsPage
  !insertmacro MUI_HEADER_TEXT $(DrivePage_Title) $(DrivePage_Title2)
  nsDialogs::Create 1018
  
  ${If} $DestDrive == ""
   GetDlgItem $6 $HWNDPARENT 1 ; Get "Next" control handle
   EnableWindow $6 0 ; disable "Next" control
  ${EndIf}
  
  ${NSD_CreateLabel} 0 0 100% 70 $(DrivePage_Text)
  Pop $PageDescr
  
  ${NSD_CreateLabel} 0 90 40% 15 $(DrivePage_Input)
  Pop $DriveSelect
  
  ${NSD_CreateDroplist} 0 110 15% 20 ""
  Pop $DestDriveHw
  ${NSD_OnChange} $DestDriveHw db_select.onchange
  ${GetDrives} "FDD+HDD" driveListFiller
  ${If} $DestDrive != ""
  ${NSD_CB_SelectString} $DestDriveHw $DestDrive
  ${EndIf}
  
; Casper-RW Selection Starts
  ${NSD_CreateLabel} 0 145 100% 15 $(Casper_Text)
  Pop $CasperSelection  
  
; CasperSlider - TrackBar
  !define TBM_SETPOS 0x0405
  !define TBM_GETPOS 0x0400
  !define TBM_SETRANGEMIN 0x0407
  !define TBM_SETRANGEMAX 0x0408

  nsDialogs::CreateControl "msctls_trackbar32" "0x50010000|0x00000018" "" 0 165 50% 25 ""
  Pop $CasperSlider
  
  ${NSD_CreateLabel} 52% 170 30% 25 ""
  Pop $SlideSpot    

  SendMessage $CasperSlider ${TBM_SETRANGEMIN} 1 256 ; Min Range Value 256
  SendMessage $CasperSlider ${TBM_SETRANGEMAX} 1 4090 ; Max Range Value 4090
  ${NSD_OnNotify} $CasperSlider onNotify_CasperSlider      
  
  nsDialogs::Show
FunctionEnd

Function driveListFiller
	SendMessage $DestDriveHw ${CB_ADDSTRING} 0 "STR:$9"
	Push 1 ; must push something - see GetDrives documentation
FunctionEnd

Function db_select.onchange
  Pop $DestDriveHw
  ${NSD_GetText} $DestDriveHw $0
  StrCpy $DestDrive $0 -1
  GetDlgItem $6 $HWNDPARENT 1 ; Get "Next" control handle
  EnableWindow $6 1 ; enable "Next" control
FunctionEnd

Function HaveSpace ; Check space required before installing
  StrCpy $0 '$0' ; check how much free space is left
  Call FreeDiskSpace
  StrCpy $2 $Casper ; Free space required by you (in MB)
  System::Int64Op $1 > $2 ; Compare the space required and the space available
  Pop $3 ; Get the result ...
  IntCmp $3 1 okay ; ... and compare it
  MessageBox MB_ICONSTOP|MB_OK "Oops: There is not enough Free disk space! $1 MB of $2 MB Needed on $0 Drive."
  quit ; Close the program if the disk space was too small...
  okay: ; Proceed to execute...
FunctionEnd

Function FreeDiskSpace
${DriveSpace} "$0" "/D=F /S=M" $1
FunctionEnd

Function CasperScript
${If} $Casper != "0"
DetailPrint "Now Creating a Casper RW File" 
DetailPrint "Creating the Persistent File: The progress bar will not move until finished. Please be patient..." 

  ExecWait '"$PLUGINSDIR\dd.exe" if=/dev/zero of=$DestDrive\casper-rw bs=1M count=$Casper --progress'
  ;nsExec::ExecToStack '"$PLUGINSDIR\dd.exe" if=/dev/zero of=$DestDrive\casper-rw bs=1M count=$Casper --progress'
  nsExec::ExecToLog '"$PLUGINSDIR\mke2fs.exe" -L casper-rw $DestDrive\casper-rw'	
${EndIf}
  CopyFiles "$PLUGINSDIR\Readme.txt" "$DestDrive\Readme.txt" ; move Readme
  CopyFiles "$PLUGINSDIR\Copying" "$DestDrive\Copying" ; move Copying   
FunctionEnd

Function onNotify_CasperSlider
Pop $Casper
SendMessage $CasperSlider ${TBM_GETPOS} 0 0 $Casper ; Get Trackbar position
${NSD_SetText} $SlideSpot "$Casper MB"
FunctionEnd

; ---- Let's Do This Stuff ----
Section  
Call HaveSpace ; Got enough Space? Lets Check!
Call CasperScript
SectionEnd

Function .onInit
SetShellVarContext all
InitPluginsDir
  File /oname=$PLUGINSDIR\dd.exe "dd.exe"
  File /oname=$PLUGINSDIR\mke2fs.exe "mke2fs.exe"
  File /oname=$PLUGINSDIR\Readme.txt "Readme.txt"
  File /oname=$PLUGINSDIR\Copying "Copying" 
FunctionEnd 